import * as yup from 'yup'
import { Implementation } from 'src/models'

export type CreateImplementationSchema = Pick<
  Implementation,
  'name' | 'description'
>

const IMPLEMENTATION_NAME_MAX_LENGHT = 255

export const createImplementationSchema = yup
  .object()
  .shape<CreateImplementationSchema>({
    name: yup
      .string()
      .max(
        IMPLEMENTATION_NAME_MAX_LENGHT,
        `El nombre debe tener menos de ${IMPLEMENTATION_NAME_MAX_LENGHT} caracteres`
      )
      .required('El nombre es requerido'),
    description: yup.string().required('La descripcion es requerida'),
  })
