import { AxiosError } from 'axios'
import { useMutation as useRQMutation, UseMutationOptions } from 'react-query'

import { Implementation } from 'src/models'
import axiosService from 'src/services/axios-service'

export namespace RunTestsMutation {
  export type Params = { id: Implementation['id'] }
  export type Response = string

  export const key = ['implementation', 'run-tests']

  export const mutationFn = (params: Params) =>
    axiosService
      .post<Response>(`/implementation/${params.id}/run-tests`, params)
      .then((res) => res.data)

  export const useMutation = (
    options: UseMutationOptions<Response, AxiosError, Params> = {}
  ) => {
    return useRQMutation(mutationFn, { ...options, mutationKey: key })
  }
}
